"""
    EMIL InsuranceService

    The EMIL InsuranceService API description  # noqa: E501

    The version of the OpenAPI document: 1.0
    Contact: kontakt@emil.de
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from eis.insurance.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from eis.insurance.exceptions import ApiAttributeError



class GrpcCloneLeadAccountRequestDto(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('title',): {
            'EMPTY': "",
            'DR.': "Dr.",
            'DR._MED.': "Dr. med.",
            'PROF.': "Prof.",
        },
        ('type',): {
            'PERSON': "person",
            'ORG': "org",
        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'title': (str,),  # noqa: E501
            'first_name': (str,),  # noqa: E501
            'last_name': (str,),  # noqa: E501
            'email': (str,),  # noqa: E501
            'gender': (str,),  # noqa: E501
            'street': (str,),  # noqa: E501
            'zip_code': (str,),  # noqa: E501
            'city': (str,),  # noqa: E501
            'house_number': (str,),  # noqa: E501
            'birth_date': (datetime,),  # noqa: E501
            'phone': (str,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'company_name': (str,),  # noqa: E501
            'account_number': (str,),  # noqa: E501
            'custom_fields': ({str: (bool, date, datetime, dict, float, int, list, str, none_type)},),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'title': 'title',  # noqa: E501
        'first_name': 'firstName',  # noqa: E501
        'last_name': 'lastName',  # noqa: E501
        'email': 'email',  # noqa: E501
        'gender': 'gender',  # noqa: E501
        'street': 'street',  # noqa: E501
        'zip_code': 'zipCode',  # noqa: E501
        'city': 'city',  # noqa: E501
        'house_number': 'houseNumber',  # noqa: E501
        'birth_date': 'birthDate',  # noqa: E501
        'phone': 'phone',  # noqa: E501
        'type': 'type',  # noqa: E501
        'company_name': 'companyName',  # noqa: E501
        'account_number': 'accountNumber',  # noqa: E501
        'custom_fields': 'customFields',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """GrpcCloneLeadAccountRequestDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (str): Optional field to enter the honorific title you want to be called.. [optional]  # noqa: E501
            first_name (str): The account's holder first name.     The account's first name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            last_name (str): The account's holder first name.     The account's first name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            email (str): The account's holder email address. It is displayed alongside the account in your dashboard       and can be useful for searching and tracking.       The account's email address will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            gender (str): The account's holder gender.     The account's gender will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            street (str): The account's holder street name.     The account's street name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            zip_code (str): The account's holder ZIP or postal code.     The account's ZIP or postal code will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            city (str): The account's holder city, district, suburb, town, or village.     The account's city will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            house_number (str): The account's holder house number.     The account's house number will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            birth_date (datetime): The account's holder date of birth (Required for account of type person).     The account's date of birth will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            phone (str): The account's holder phone number.     The account's phone number will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            type (str): The account's type. Default value is person. [optional] if omitted the server will use the default value of "person"  # noqa: E501
            company_name (str): The account's company name (Required for account of type org).     The account's company name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            account_number (str): Account number.. [optional]  # noqa: E501
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional custom fields for account. It could be included additional required/optional fields       that the account would need for specific cases.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', True)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """GrpcCloneLeadAccountRequestDto - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            title (str): Optional field to enter the honorific title you want to be called.. [optional]  # noqa: E501
            first_name (str): The account's holder first name.     The account's first name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            last_name (str): The account's holder first name.     The account's first name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            email (str): The account's holder email address. It is displayed alongside the account in your dashboard       and can be useful for searching and tracking.       The account's email address will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            gender (str): The account's holder gender.     The account's gender will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            street (str): The account's holder street name.     The account's street name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            zip_code (str): The account's holder ZIP or postal code.     The account's ZIP or postal code will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            city (str): The account's holder city, district, suburb, town, or village.     The account's city will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            house_number (str): The account's holder house number.     The account's house number will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            birth_date (datetime): The account's holder date of birth (Required for account of type person).     The account's date of birth will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            phone (str): The account's holder phone number.     The account's phone number will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            type (str): The account's type. Default value is person. [optional] if omitted the server will use the default value of "person"  # noqa: E501
            company_name (str): The account's company name (Required for account of type org).     The account's company name will be validated if the 'validate' flag is set to true.. [optional]  # noqa: E501
            account_number (str): Account number.. [optional]  # noqa: E501
            custom_fields ({str: (bool, date, datetime, dict, float, int, list, str, none_type)}): Optional custom fields for account. It could be included additional required/optional fields       that the account would need for specific cases.. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            for arg in args:
                if isinstance(arg, dict):
                    kwargs.update(arg)
                else:
                    raise ApiTypeError(
                        "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                            args,
                            self.__class__.__name__,
                        ),
                        path_to_item=_path_to_item,
                        valid_classes=(self.__class__,),
                    )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
